/* 
 * SDP-K1 eval software
 * Data received on one Serial interface will be sent out on the other, I.E from PC -> SDP will be sent from SDP-> UART and vice versa.
 */

#include "mbed.h"
#include "platform/mbed_thread.h"
#define SLEEP_TIME                  20
#include <string>


static BufferedSerial pc(USBTX, USBRX,9600); // for USB Serial between SDP and PC
static BufferedSerial uart(D1, D0,9600); // Serial between SDP and LTC2862A

DigitalOut pc_activity(LED1); //red led

DigitalOut pctouart(LED2); //orange led indicates sending to UART

DigitalOut uarttopc(LED3); //green led indicates receiving on UART


DigitalOut DE(D2); // driver enable
DigitalOut RE_N(D3); //reciever enable
string pc2uart;
string uart2pc;

int main()
{
    pctouart.write(0); // led2 for sending to UART
    uarttopc.write(0); // led3 for recieving from UART
    DE.write(1); // enable driver
    RE_N.write(0); //enable reciever
    
    pc_activity.write(1); //RED LED on to show board is on
    string pc2uart;
    string uart2pc;
    while (1) {
        if (uart.readable()) {
            uarttopc.write(1); // turn led on to show recieving

            uart.read(&uart2pc, sizeof(uart2pc)); //read from uart
            pc.write(&uart2pc, sizeof(uart2pc)); //send to PC
            uarttopc.write(0); // turn led off after recieving

        }
        if (pc.readable()) {
            pctouart.write(1); // turn led on to show sending to UART
            pc.read(&pc2uart, sizeof(pc2uart)); //read from PC
            uart.write(&pc2uart, sizeof(pc2uart)); //send to uart
            pctouart.write(0); // turn led off to show finished sending to UART

         }

    }
    
}